Package org.eclipse.emf.cdo.security

## Interface Realm

- All Superinterfaces:
    `CDOObject`, `CDOWithID`, `org.eclipse.emf.ecore.EObject`, `ModelElement`, `org.eclipse.emf.common.notify.Notifier`, `SecurityElement`, `SecurityItemContainer`, `SecurityItemProvider`
  All Known Implementing Classes:
    `RealmImpl`

      public interface Realm
      extends SecurityElement, SecurityItemContainer

  A representation of the model object 'Realm'.
  See Also:
    `SecurityPackage.getRealm()`
  Generated
  Extends
    SecurityItemContainer
  Model
    annotation="http://www.eclipse.org/emf/2002/Ecore constraints='HasAdministrator'"
  No Implement
    This interface is not intended to be implemented by clients.
  No Extend
    This interface is not intended to be extended by clients.

    The following features are supported:

    - `Items`
    - `All Users`
    - `All Groups`
    - `All Roles`
    - `All Permissions`
    - `Name`
    - `Default Access`
    - `Default User Directory`
    - `Default Group Directory`
    - `Default Role Directory`

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `org.eclipse.emf.common.util.EList<Group>` | `getAllGroups()` | Returns the value of the 'All Groups' reference list.
    `org.eclipse.emf.common.util.EList<Permission>` | `getAllPermissions()` | Returns the value of the 'All Permissions' reference list.
    `org.eclipse.emf.common.util.EList<Role>` | `getAllRoles()` | Returns the value of the 'All Roles' reference list.
    `org.eclipse.emf.common.util.EList<User>` | `getAllUsers()` | Returns the value of the 'All Users' reference list.
    `Access` | `getDefaultAccess()` | Returns the value of the 'Default Access' attribute.
    `Directory` | `getDefaultGroupDirectory()` | Returns the value of the 'Default Group Directory' reference.
    `Directory` | `getDefaultRoleDirectory()` | Returns the value of the 'Default Role Directory' reference.
    `Directory` | `getDefaultUserDirectory()` | Returns the value of the 'Default User Directory' reference.
    `org.eclipse.emf.common.util.EList<SecurityItem>` | `getItems()` | Returns the value of the 'Items' containment reference list.
    `java.lang.String` | `getName()` | Returns the value of the 'Name' attribute.
    `void` | `setDefaultAccess​(Access value)` | Sets the value of the '`Default Access`' attribute.
    `void` | `setDefaultGroupDirectory​(Directory value)` | Sets the value of the '`Default Group Directory`' reference.
    `void` | `setDefaultRoleDirectory​(Directory value)` | Sets the value of the '`Default Role Directory`' reference.
    `void` | `setDefaultUserDirectory​(Directory value)` | Sets the value of the '`Default User Directory`' reference.
    `void` | `setName​(java.lang.String value)` | Sets the value of the '`Name`' attribute.

    - ### Methods inherited from interface org.eclipse.emf.cdo.CDOObject

      `cdoConflict, cdoDirectResource, cdoHistory, cdoID, cdoInvalid, cdoLockState, cdoPermission, cdoPrefetch, cdoReadLock, cdoReload, cdoResource, cdoRevision, cdoRevision, cdoState, cdoView, cdoWriteLock, cdoWriteOption`

    - ### Methods inherited from interface org.eclipse.emf.ecore.EObject

      `eAllContents, eClass, eContainer, eContainingFeature, eContainmentFeature, eContents, eCrossReferences, eGet, eGet, eInvoke, eIsProxy, eIsSet, eResource, eSet, eUnset`

    - ### Methods inherited from interface org.eclipse.emf.cdo.etypes.ModelElement

      `getAnnotation, getAnnotations`

    - ### Methods inherited from interface org.eclipse.emf.common.notify.Notifier

      `eAdapters, eDeliver, eNotify, eSetDeliver`

    - ### Methods inherited from interface org.eclipse.emf.cdo.security.SecurityElement

      `getRealm`

    - ### Methods inherited from interface org.eclipse.emf.cdo.security.SecurityItemContainer

      `addGroup, addRole, addUser, addUser, addUser, removeGroup, removeRole, removeUser, setPassword`

    - ### Methods inherited from interface org.eclipse.emf.cdo.security.SecurityItemProvider

      `getGroup, getRole, getUser`

- - ### Method Detail

    - #### getItems

          org.eclipse.emf.common.util.EList<SecurityItem> getItems()

      Returns the value of the 'Items' containment reference list. The list contents are of type `SecurityItem`.

      If the meaning of the 'Items' containment reference list isn't clear, there really should be more of a description here...

      Returns:
        the value of the 'Items' containment reference list.
      See Also:
        `SecurityPackage.getRealm_Items()`
      Generated
      Model
        containment="true"

    - #### getAllUsers

          org.eclipse.emf.common.util.EList<User> getAllUsers()

      Returns the value of the 'All Users' reference list. The list contents are of type `User`.

      If the meaning of the 'All Users' reference list isn't clear, there really should be more of a description here...

      Returns:
        the value of the 'All Users' reference list.
      See Also:
        `SecurityPackage.getRealm_AllUsers()`
      Generated
      Model
        transient="true" changeable="false" volatile="true" derived="true"

    - #### getAllGroups

          org.eclipse.emf.common.util.EList<Group> getAllGroups()

      Returns the value of the 'All Groups' reference list. The list contents are of type `Group`.

      If the meaning of the 'All Groups' reference list isn't clear, there really should be more of a description here...

      Returns:
        the value of the 'All Groups' reference list.
      See Also:
        `SecurityPackage.getRealm_AllGroups()`
      Generated
      Model
        transient="true" changeable="false" volatile="true" derived="true"

    - #### getAllRoles

          org.eclipse.emf.common.util.EList<Role> getAllRoles()

      Returns the value of the 'All Roles' reference list. The list contents are of type `Role`.

      If the meaning of the 'All Roles' reference list isn't clear, there really should be more of a description here...

      Returns:
        the value of the 'All Roles' reference list.
      See Also:
        `SecurityPackage.getRealm_AllRoles()`
      Generated
      Model
        transient="true" changeable="false" volatile="true" derived="true"

    - #### getAllPermissions

          org.eclipse.emf.common.util.EList<Permission> getAllPermissions()

      Returns the value of the 'All Permissions' reference list. The list contents are of type `Permission`.

      If the meaning of the 'All Permissions' reference list isn't clear, there really should be more of a description here...

      Returns:
        the value of the 'All Permissions' reference list.
      See Also:
        `SecurityPackage.getRealm_AllPermissions()`
      Generated
      Model
        transient="true" changeable="false" volatile="true" derived="true"

    - #### getName

          java.lang.String getName()

      Returns the value of the 'Name' attribute.

      If the meaning of the 'Name' attribute isn't clear, there really should be more of a description here...

      Returns:
        the value of the 'Name' attribute.
      See Also:
        `setName(String)`, `SecurityPackage.getRealm_Name()`
      Generated
      Model

    - #### setName

          void setName​(java.lang.String value)

      Sets the value of the '`Name`' attribute.
      Parameters:
        `value` - the new value of the 'Name' attribute.
      See Also:
        `getName()`
      Generated

    - #### getDefaultAccess

          Access getDefaultAccess()

      Returns the value of the 'Default Access' attribute.

      The minimum level of access for all users on all objects in the repository. This is not the default level of access for a user on an object that is not otherwise covered by some permission rule; all permissions are implicitly elevated to this level.

      This default/minimum can be overridden, even to a lesser access level, for specific users on a case-by-case basis.

      Returns:
        the value of the 'Default Access' attribute.
      See Also:
        `setDefaultAccess(Access)`, `SecurityPackage.getRealm_DefaultAccess()`
      Generated
      Model
        dataType="org.eclipse.emf.cdo.security.AccessObject"

    - #### setDefaultAccess

          void setDefaultAccess​(Access value)

      Sets the value of the '`Default Access`' attribute.
      Parameters:
        `value` - the new value of the 'Default Access' attribute.
      See Also:
        `getDefaultAccess()`
      Generated

    - #### getDefaultUserDirectory

          Directory getDefaultUserDirectory()

      Returns the value of the 'Default User Directory' reference.

      If the meaning of the 'Default User Directory' reference isn't clear, there really should be more of a description here...

      Returns:
        the value of the 'Default User Directory' reference.
      Since:
        4.2
      See Also:
        `setDefaultUserDirectory(Directory)`, `SecurityPackage.getRealm_DefaultUserDirectory()`
      Generated
      Model

    - #### setDefaultUserDirectory

          void setDefaultUserDirectory​(Directory value)

      Sets the value of the '`Default User Directory`' reference.
      Parameters:
        `value` - the new value of the 'Default User Directory' reference.
      Since:
        4.2
      See Also:
        `getDefaultUserDirectory()`
      Generated

    - #### getDefaultGroupDirectory

          Directory getDefaultGroupDirectory()

      Returns the value of the 'Default Group Directory' reference.

      If the meaning of the 'Default Group Directory' reference isn't clear, there really should be more of a description here...

      Returns:
        the value of the 'Default Group Directory' reference.
      Since:
        4.2
      See Also:
        `setDefaultGroupDirectory(Directory)`, `SecurityPackage.getRealm_DefaultGroupDirectory()`
      Generated
      Model

    - #### setDefaultGroupDirectory

          void setDefaultGroupDirectory​(Directory value)

      Sets the value of the '`Default Group Directory`' reference.
      Parameters:
        `value` - the new value of the 'Default Group Directory' reference.
      Since:
        4.2
      See Also:
        `getDefaultGroupDirectory()`
      Generated

    - #### getDefaultRoleDirectory

          Directory getDefaultRoleDirectory()

      Returns the value of the 'Default Role Directory' reference.

      If the meaning of the 'Default Role Directory' reference isn't clear, there really should be more of a description here...

      Returns:
        the value of the 'Default Role Directory' reference.
      Since:
        4.2
      See Also:
        `setDefaultRoleDirectory(Directory)`, `SecurityPackage.getRealm_DefaultRoleDirectory()`
      Generated
      Model

    - #### setDefaultRoleDirectory

          void setDefaultRoleDirectory​(Directory value)

      Sets the value of the '`Default Role Directory`' reference.
      Parameters:
        `value` - the new value of the 'Default Role Directory' reference.
      Since:
        4.2
      See Also:
        `getDefaultRoleDirectory()`
      Generated